#include <iostream>
#include <bits/stdc++.h>
using namespace std;

int main()
{
    short int x;
    int a, b;
    cin>> x;
    int niz[x];
    for(int k = 0; k < x; k++)
    {
        cin>>a>>b;
        long long int niz1[a], niz2[b], r;
        short int w;
        for(int i = 0; i < a; i++)
        {
            cin>>niz1[i];
        }
        for(int i = 0; i < b; i++)
        {
            cin>>niz2[i];
        }
        sort(niz1, niz1 + a);
        sort(niz2, niz2 + b);
        w = 1;
        for(int i = 0; i < a; i++)
        {
            if(niz1[i]%(niz1[1]-niz1[0]) != niz1[0]%(niz1[1]-niz1[0]))
            {
                w = 0;
                break;
            }
        }
        if(w == 1)
        {
            for(int i = 0; i < a; i++)
            {
                    if(niz2[i]%(niz1[1]-niz1[0]) == niz1[0]%(niz1[1]-niz1[0]))
                    {
                        w = 0;
                        break;
                    }
            }
        }
        niz[k] = w;
    }
    for(int i = 0; i < x;i++)
    {
        cout<<niz[i]<<"\n";
    }
    return 0;
}